Attribute VB_Name = "modMain"
Option Explicit

Public Const vbBage = &H80000000
Public Const vbGrey = &H808080
Public Const vbTeal = &HFFFF00
Public Const vbDGreen = &H8000&

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef Destination As Any, ByRef source As Any, ByVal numbytes As Long)


Public Function StrToHex(ByVal String1 As String) As String
    Dim strTemp As String, strReturn As String, I As Long
    For I = 1 To Len(String1)
        strTemp = Hex(Asc(Mid(String1, I, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    strReturn = strReturn & " " & strTemp
    Next I
        StrToHex = strReturn
End Function

Public Function DebugOutput(ByVal sIn As String) As String
   Dim x1 As Long, y1 As Long
   Dim iLen As Long, iPos As Long
   Dim sB As String, sT As String
   Dim sOut As String
   
   iLen = Len(sIn)
   If iLen = 0 Then Exit Function
   sOut = ""
   For x1 = 0 To ((iLen - 1) \ 16)
       sB = String(48, " ")
       sT = "................"
       For y1 = 1 To 16
           iPos = 16 * x1 + y1
           If iPos > iLen Then Exit For
           Mid(sB, 3 * (y1 - 1) + 1, 2) = Right("00" & Hex(Asc(Mid(sIn, iPos, 1))), 2) & " "
           Select Case Asc(Mid(sIn, iPos, 1))
           Case 32 To 255
               Mid(sT, y1, 1) = Mid(sIn, iPos, 1)
           End Select
       Next y1
       If Len(sOut) > 0 Then sOut = sOut & vbCrLf
       sOut = sOut & sB & "  " & sT
   Next x1
   DebugOutput = sOut
End Function

Public Sub AddChat(Text As String, Color As String, Optional UseTimer As Boolean = True)

    If UseTimer = True Then
        With frmMain.rtbChat
            .SelStart = Len(.Text)
                .SelColor = vbWhite
            .SelText = "[" & Format(Time, "hh:mm:ss") & "] "
        End With
    End If
    
    With frmMain.rtbChat
        .SelStart = Len(.Text)
            .SelColor = Color
        .SelText = Text
    End With
    

End Sub


Public Function GetDWORD(Data As String) As Long

    Dim lReturn As Long
    Call CopyMemory(lReturn, ByVal Data, 4)
    
    GetDWORD = lReturn
End Function

Public Function GetWORD(Data As String) As Long
    Dim lReturn As Long
    Call CopyMemory(lReturn, ByVal Data, 2)
    GetWORD = lReturn
End Function

Public Function GetNTString(Data As String) As String

Data = Data & Chr(0)
GetNTString = Mid(Data, 1, InStr(Data, Chr(0)) - 1)

End Function

Public Function ToStr(ByVal strString As String) As String
strString = Replace(strString, " ", "")
Dim a&, strOut$, strC$
For a = 1 To Len(strString) Step 2
       strOut = strOut & Chr(Val("&H" & Mid(strString, a, 2)))
Next a
ToStr = strOut
End Function

Public Sub Delay(N)
Dim Zeit1 As Variant
    Zeit1 = Timer
        Do
            DoEvents
                If Timer < Zeit1 Then N = N - 86400
                
                Sleep (50)
        Loop Until (Timer - Zeit1 > N)
End Sub

