Attribute VB_Name = "modDecode"
Option Explicit
Public Declare Function GamePacketDecode Lib "D2GS.dll" (ByVal indata As String, ByVal insize As Long, ByVal outdata As String, ByVal outmax As Long, ByRef outsize As Long) As Integer

Public D2GS_PackLen(179) As Long

Private D2Packets As New clsD2Packets

Public Sub Init_PackLen()
D2GS_PackLen(0) = &H1
D2GS_PackLen(1) = &H8
D2GS_PackLen(2) = &H1
D2GS_PackLen(3) = &HC
D2GS_PackLen(4) = &H1
D2GS_PackLen(5) = &H1
D2GS_PackLen(6) = &H1
D2GS_PackLen(7) = &H6
D2GS_PackLen(8) = &H6
D2GS_PackLen(9) = &HB
D2GS_PackLen(10) = &H6
D2GS_PackLen(11) = &H6
D2GS_PackLen(12) = &H9
D2GS_PackLen(13) = &HD
D2GS_PackLen(14) = &HC
D2GS_PackLen(15) = &H10
D2GS_PackLen(16) = &H10
D2GS_PackLen(17) = &H8
D2GS_PackLen(18) = &H1
D2GS_PackLen(19) = &HE
D2GS_PackLen(20) = &H12
D2GS_PackLen(21) = &HB
D2GS_PackLen(22) = -1
D2GS_PackLen(23) = 0
D2GS_PackLen(24) = &H28
D2GS_PackLen(25) = &H2
D2GS_PackLen(26) = &H2
D2GS_PackLen(27) = &H3
D2GS_PackLen(28) = &H5
D2GS_PackLen(29) = &H3
D2GS_PackLen(30) = &H4
D2GS_PackLen(31) = &H6
D2GS_PackLen(32) = &HA
D2GS_PackLen(33) = &HC
D2GS_PackLen(34) = &HC
D2GS_PackLen(35) = &HD
D2GS_PackLen(36) = &H5A
D2GS_PackLen(37) = &H5A
D2GS_PackLen(38) = -1
D2GS_PackLen(39) = &H28
D2GS_PackLen(40) = &H67
D2GS_PackLen(41) = &H61
D2GS_PackLen(42) = &HF
D2GS_PackLen(43) = &H0
D2GS_PackLen(44) = &H8
D2GS_PackLen(45) = &H0
D2GS_PackLen(46) = &H0
D2GS_PackLen(47) = &H0
D2GS_PackLen(48) = &H0
D2GS_PackLen(49) = &H0
D2GS_PackLen(50) = &H0
D2GS_PackLen(51) = &H0
D2GS_PackLen(52) = &H0
D2GS_PackLen(53) = &H0
D2GS_PackLen(54) = &H0
D2GS_PackLen(55) = &H0
D2GS_PackLen(56) = &H0
D2GS_PackLen(57) = &H0
D2GS_PackLen(58) = &H0
D2GS_PackLen(59) = &H0
D2GS_PackLen(60) = &H0
D2GS_PackLen(61) = &H0
D2GS_PackLen(62) = -1
D2GS_PackLen(63) = &H9
D2GS_PackLen(64) = &HD
D2GS_PackLen(65) = &H0
D2GS_PackLen(66) = &H6
D2GS_PackLen(67) = &H0
D2GS_PackLen(68) = &H0
D2GS_PackLen(69) = &HD
D2GS_PackLen(70) = &H0
D2GS_PackLen(71) = &HB
D2GS_PackLen(72) = &HB
D2GS_PackLen(73) = &H0
D2GS_PackLen(74) = &H0
D2GS_PackLen(75) = &H0
D2GS_PackLen(76) = &H10
D2GS_PackLen(77) = &H11
D2GS_PackLen(78) = &H7
D2GS_PackLen(79) = &H1
D2GS_PackLen(80) = &HF
D2GS_PackLen(81) = &HE
D2GS_PackLen(82) = &H2A
D2GS_PackLen(83) = &HA
D2GS_PackLen(84) = &H3
D2GS_PackLen(85) = &H0
D2GS_PackLen(86) = &H0
D2GS_PackLen(87) = &HE
D2GS_PackLen(88) = &H7
D2GS_PackLen(89) = &H1A
D2GS_PackLen(90) = &H28
D2GS_PackLen(91) = -1
D2GS_PackLen(92) = &H5
D2GS_PackLen(93) = &H6
D2GS_PackLen(94) = &H26
D2GS_PackLen(95) = &H5
D2GS_PackLen(96) = &H7
D2GS_PackLen(97) = &H2
D2GS_PackLen(98) = &H7
D2GS_PackLen(99) = &H15
D2GS_PackLen(100) = &H0
D2GS_PackLen(101) = &H7
D2GS_PackLen(102) = &H7
D2GS_PackLen(103) = &H10
D2GS_PackLen(104) = &H15
D2GS_PackLen(105) = &HC
D2GS_PackLen(106) = &HC
D2GS_PackLen(107) = &H10
D2GS_PackLen(108) = &H10
D2GS_PackLen(109) = &HA
D2GS_PackLen(110) = &H1
D2GS_PackLen(111) = &H1
D2GS_PackLen(112) = &H1
D2GS_PackLen(113) = &H1
D2GS_PackLen(114) = &H1
D2GS_PackLen(115) = &H20
D2GS_PackLen(116) = &HA
D2GS_PackLen(117) = &HD
D2GS_PackLen(118) = &H6
D2GS_PackLen(119) = &H2
D2GS_PackLen(120) = &H15
D2GS_PackLen(121) = &H6
D2GS_PackLen(122) = &HD
D2GS_PackLen(123) = &H8
D2GS_PackLen(124) = &H6
D2GS_PackLen(125) = &H12
D2GS_PackLen(126) = &H5
D2GS_PackLen(127) = &HA
D2GS_PackLen(128) = &H0
D2GS_PackLen(129) = &H14
D2GS_PackLen(130) = &H1D
D2GS_PackLen(131) = &H0
D2GS_PackLen(132) = &H0
D2GS_PackLen(133) = &H0
D2GS_PackLen(134) = &H0
D2GS_PackLen(135) = &H0
D2GS_PackLen(136) = &H0
D2GS_PackLen(137) = &H2
D2GS_PackLen(138) = &H6
D2GS_PackLen(139) = &H6
D2GS_PackLen(140) = &HB
D2GS_PackLen(141) = &H7
D2GS_PackLen(142) = &HA
D2GS_PackLen(143) = &H21
D2GS_PackLen(144) = &HD
D2GS_PackLen(145) = &H1A
D2GS_PackLen(146) = &H6
D2GS_PackLen(147) = &H8
D2GS_PackLen(148) = -1
D2GS_PackLen(149) = &HD
D2GS_PackLen(150) = &H9
D2GS_PackLen(151) = &H1
D2GS_PackLen(152) = &H7
D2GS_PackLen(153) = &H10
D2GS_PackLen(154) = &H11
D2GS_PackLen(155) = &H7
D2GS_PackLen(156) = -1
D2GS_PackLen(157) = -1
D2GS_PackLen(158) = &H7
D2GS_PackLen(159) = &H8
D2GS_PackLen(160) = &HA
D2GS_PackLen(161) = &H7
D2GS_PackLen(162) = &H8
D2GS_PackLen(163) = &H18
D2GS_PackLen(164) = &H3
D2GS_PackLen(165) = &H8
D2GS_PackLen(166) = -1
D2GS_PackLen(167) = &H7
D2GS_PackLen(168) = -1
D2GS_PackLen(169) = &H7
D2GS_PackLen(170) = -1
D2GS_PackLen(171) = &H7
D2GS_PackLen(172) = -1
D2GS_PackLen(173) = &H9
D2GS_PackLen(174) = -1
D2GS_PackLen(175) = &H1
D2GS_PackLen(176) = &H0
D2GS_PackLen(177) = &H35
D2GS_PackLen(178) = -1
D2GS_PackLen(179) = &H5
End Sub

Public Sub DoData(ByVal cData As String)
On Error Resume Next

    Dim strBuffer As String
    Dim TempRecv As String
    Dim lngLen As Long
    Dim dLen As Long

    strBuffer = cData
    
    dLen = GPSize(strBuffer)
    
    If Len(strBuffer) < dLen Then Exit Sub
    
    TempRecv = String(dLen * 2 + 250, Chr(0))
            
    Call DataDecomp(strBuffer, dLen, TempRecv)
        
        
    Do Until Len(TempRecv) < 1
   
        lngLen = D2GS_PackLen(Asc(Mid(TempRecv, 1, 1)))
        
        If lngLen = 0 Then
            Exit Sub
        End If
   
        If lngLen = -1 Then
            lngLen = GetVerySize(TempRecv)
        End If
   
        If lngLen = -1 Then
            AddChat "Unknown packet size: " & StrToHex(TempRecv) & vbCrLf, vbRed
                Exit Sub
            Else
   
             D2Packets.Parse (Left(TempRecv, lngLen))
   
                TempRecv = Mid(TempRecv, lngLen + 1)
                
        End If
   
        DoEvents
        
   Loop


End Sub

Private Function DataDecomp(Data As String, ByVal pSize As Long, outBuf As String) As Long
    On Error Resume Next
    
    Dim SizeReturn As Long
    
    DataDecomp = GamePacketDecode(Left(Data, pSize + 1), Len(Left(Data, pSize)) + 1, outBuf, Len(outBuf), SizeReturn)
    
    outBuf = Left(outBuf, SizeReturn)
    
    Data = Mid(Data, 2 + pSize)
End Function

Private Function GPSize(D As String) As Long
On Error Resume Next

    If Asc(Mid(D, 1, 1)) < &HF0 Then
    
        GPSize = Asc(Mid(D, 1, 1)) - 2
        
        D = Mid(D, 2)
        
    Else
    
        GPSize = LeftShift(Asc(Mid(D, 1, 1)) And &HF, 8) + Asc(Mid(D, 2, 1)) - 3
        
        D = Mid(D, 3)
        
    End If
    
End Function

Private Function LeftShift(ByVal Value As Long, ByVal Shift As Long) As Double

    LeftShift = CDbl(Value * (2 ^ Shift))
    
End Function

Public Function GetVerySize(ByVal Data As String) As Long
On Error Resume Next

    Select Case Asc(Mid(Data, 1, 1))
    
        Case &H94: GetVerySize = 6 + (Asc(Mid(Data, 2, 1)) * 3)
        Case &H9C: GetVerySize = Asc(Mid(Data, 3, 1))
        Case &H9D: GetVerySize = Asc(Mid(Data, 3, 1))
        Case &HAA: GetVerySize = Asc(Mid(Data, 7, 1))
        Case &HA8: GetVerySize = Asc(Mid(Data, 7, 1))
        Case &HAC: GetVerySize = Asc(Mid(Data, 13, 1))
        Case &H5B: GetVerySize = Asc(Mid(Data, 2, 1))
        Case &HAE: GetVerySize = 3 + Asc(Mid(Data, 2, 1))
        
    Case Else: GetVerySize = -1
    
End Select
End Function

